var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var defaultImageUrl = 'https://images.cache.timepack.cn/o_1c05o45jg1jl81f571jk9ipehkhc.png';
var Util = {
    DOMAIN: 'https://images.cache.timepack.cn/',
    TEMPLATE_DOMAIN: 'http://template.cache.timepack.cn/',
    THUMB600: '?imageMogr2/thumbnail/600x600'
};
var EMPTY = '';

var MCanvas = function () {
    function MCanvas(filter) {
        _classCallCheck(this, MCanvas);

        console.log('\u521D\u59CB\u5316timepack-album-model');
        this.openFilter = undefined == filter ? false : filter;
        this.boxWidth = window.innerWidth * 0.8;
        this.photo = null;
        this.layout = null;
        this.temp = null;
    }

    _createClass(MCanvas, [{
        key: 'render',
        value: function render(photo, layout, temp) {

            if (null != photo) {
                this.photo = photo;
            }

            if (null != layout) {
                this.layout = layout;
            }

            if (null != temp) {
                this.temp = temp;
            }

            return this;
        }
    }, {
        key: 'getInstance',
        value: function getInstance() {
            return this;
        }
    }, {
        key: 'getPhoto',
        value: function getPhoto() {
            return this.photo;
        }
    }, {
        key: 'setPhoto',
        value: function setPhoto(a) {
            this.photo = a;
            return this;
        }
    }, {
        key: 'getLayout',
        value: function getLayout() {
            return this.layout;
        }
    }, {
        key: 'setLayout',
        value: function setLayout(a) {
            this.layout = a;
            return this;
        }
    }, {
        key: 'getTemp',
        value: function getTemp() {
            return this.temp;
        }
    }, {
        key: 'setTemp',
        value: function setTemp(a) {
            this.temp = a;
            return this;
        }
    }, {
        key: 'getter',
        value: function getter() {
            var that = this;
            return {
                template: function template(i) {
                    return that.getTemplateImage(i);
                },
                photo: function photo(a, b, c) {
                    return that.getPhotoImage(a, b, c);
                },
                radio: function radio(i) {
                    return that.getLayoutRadio(i);
                },
                rest: function rest() {
                    return that.getRestCount();
                },
                pageRest: function pageRest(i) {
                    return that.getRestCountByPage(i);
                },
                sortGroupImage: function sortGroupImage(a) {
                    return that.splitGroupImageObject(a);
                }
            };
        }
    }, {
        key: 'setter',
        value: function setter() {
            var that = this;
            return {
                editPageStyle: function editPageStyle(a, b, c, d) {
                    return that.setEditorPageStyle(a, b, c, d);
                },
                areaStyle: function areaStyle(a, b, c, d) {
                    return that.setAreaStyle(a, b, c, d);
                },
                photoStyle: function photoStyle(a, b) {
                    return that.setPhotoStyle(a, b);
                },
                blurStyle: function blurStyle(a, b, c, d) {
                    return that.setBlurImageStyle(a, b, c, d);
                },
                frontImageStyle: function frontImageStyle(a, b, c, d) {
                    return that.setFrontImageStyle(a, b, c, d);
                },
                groupImage: function groupImage(a) {
                    return that.fillImageByGroup(a);
                },
                sortImage: function sortImage(a) {
                    return that.fillImageBySortableGroup(a);
                },
                listImage: function listImage(a) {
                    return that.fillImageByList(a);
                },
                pageImage: function pageImage(a, b) {
                    return that.fillImageByPage(a, b);
                },
                indexImage: function indexImage(a, b, c) {
                    return that.fillImageByIndex(a, b, c);
                },
                resetLayout: function resetLayout(a) {
                    return that.updatePhotoContainer(a);
                },
                clearBlur: function clearBlur(a, b) {
                    return that.clearBlurStatus(a, b);
                },
                addBlur: function addBlur(a, b) {
                    return that.addBlurStatus(a, b);
                }
            };
        }
    }, {
        key: 'operate',
        value: function operate() {
            var that = this;
            return {
                exchange: function exchange(a, b, c) {
                    return that.exchangeImage(a, b, c);
                },
                rotate: function rotate(a, b) {
                    return that.rotateImage(a, b);
                },
                zoom: function zoom(a, b, c) {
                    return that.zoomImage(a, b, c);
                },
                convert: function convert(a) {
                    return that.convertObject2Array(a);
                },
                changeLayout: function changeLayout(a) {
                    return that.changeLayoutItem(a);
                },
                delete: function _delete(a, b) {
                    return that.deleteImageByIndex(a, b);
                }
            };
        }
    }, {
        key: 'event',
        value: function event() {
            var that = this;
            return {
                touchstart: function touchstart(a, b) {
                    return that.touchStart(a, b);
                },
                touchmove: function touchmove(a, b, c, d) {
                    that.touchMove(a, b, c, d);
                },
                touchend: function touchend(a, b, c, d, e) {
                    return that.touchEnd(a, b, c, d, e);
                }
            };
        }

        /**
         * 初始化相簿数据
         * @return {[type]} [description]
         */

    }, {
        key: 'init',
        value: function init() {
            var photoList = [];
            for (var i = 0, len = this.layout.length; i < len; i++) {
                var item = this.layout[i],
                    page = {};
                page.list = [];
                page.size = null == item.area ? 0 : item.area.length;
                page.main = item.layoutStyle.main;
                page.sub = item.layoutStyle.sub;
                page.temp = item.id;
                page.wait = 0; //初始化待插入的位置为0
                page.bw = this.boxWidth;
                page.dpr = document.documentElement.getAttribute('data-dpr');
                for (var j = 0; j < page.size; j++) {
                    var pageItem = this.getPhotoItemInitData(j);
                    page.list.push(pageItem);
                }
                photoList.push(page);
            }
            this.photo = photoList;

            return this;
        }

        /**
         * 跨设备兼容性处理
         * @return {[type]} [description]
         */

    }, {
        key: 'compatable',
        value: function compatable() {
            if (null == this.photo) return;
            var photoList = this.photo;
            for (var i = 0, len = photoList.length; i < len; i++) {
                var item = photoList[i];
                if (undefined != item.list) {
                    var bw = item.bw,
                        deviceWidthRadio = this.boxWidth / bw;
                    item.bw = this.boxWidth;
                    for (var j = 0; j < item.list.length; j++) {
                        var listItem = item.list[j];
                        for (var key in listItem.location.position) {
                            var value = listItem.location.position[key];
                            listItem.location.position[key] = Number((value * deviceWidthRadio).toFixed(2));
                        }
                    }
                }
            }
            this.photo = photoList;

            return this;
        }

        /**
         * 从容器列表中获取模板的图片
         * @param  {[Number]} index [容器列表的下标]
         * @return {[String]}       [模板图片地址]
         */

    }, {
        key: 'getTemplateImage',
        value: function getTemplateImage(index) {
            if (null === this.layout) return EMPTY;
            var item = this.layout[index];
            if (undefined == item) return EMPTY;
            return item.pngImg + Util.THUMB600;
        }

        /**
         * 从图片列表中获取用户图片,带旋转角度
         * @param  {[type]} pageIndex  [description]
         * @param  {[type]} imageIndex [description]
         * @param  {[type]} size       [description]
         * @return {[type]}            [description]
         */

    }, {
        key: 'getPhotoImage',
        value: function getPhotoImage(pageIndex, imageIndex, size) {
            var currentPhoto = this.photo[pageIndex].list;
            if (undefined != currentPhoto) {
                var photo = currentPhoto[imageIndex];
                if (EMPTY == photo.key || photo.width == 0 || undefined == photo.key) {
                    return defaultImageUrl;
                } else {
                    return encodeURI(Util.DOMAIN + photo.key + (undefined == size ? Util.THUMB600 : '?imageMogr2/thumbnail/' + size + 'x' + size) + '/rotate/' + photo.degree);
                }
            }

            return EMPTY;
        }

        /**
         * 根据容器下标获取容器的长宽比
         * @param  {[Number]} pageIndex [容器的下标]
         * @return {[Number]}           [指定容器的长宽比]
         */

    }, {
        key: 'getLayoutRadio',
        value: function getLayoutRadio(pageIndex) {
            if (null == this.layout) return 1;
            var container = this.layout[pageIndex];
            if (null == container || undefined == container) return 1;
            return container.tw / container.th;
        }

        /**
         * 获取指定页数空区域的数量(即未填充的数量)
         * @param  {[Number]} pageIndex [指定的页数]
         * @return {[Number]}           [未填充的数量]
         */

    }, {
        key: 'getRestCountByPage',
        value: function getRestCountByPage(pageIndex) {
            var photoList = this.photo;
            var item = photoList[pageIndex],
                count = 0;
            if (undefined != item.list) {
                for (var i = 0, len = item.list.length; i < len; i++) {
                    var listItem = item.list[i];
                    if (listItem.key == EMPTY || listItem.key == null || listItem.key == undefined) {
                        count += 1;
                    }
                }
            }
            return count;
        }

        /**
         * 获取整体未填充区域的数量
         * @return {[Number]}           [未填充的数量]
         */

    }, {
        key: 'getRestCount',
        value: function getRestCount() {
            var photoList = this.photo,
                count = 0;
            if (null == photoList) return count;
            for (var i = 0; i < photoList.length; i++) {
                var item = photoList[i];
                if (undefined != item.list) {
                    for (var j = 0, len = item.list.length; j < len; j++) {
                        var listItem = item.list[j];
                        if (listItem.key == EMPTY || listItem.key == null || listItem.key == undefined) {
                            count += 1;
                        }
                    }
                }
            }
            return count;
        }

        /**
         * 设置编辑页面样式
         * @param {[Number]} pageIndex  [页数]
         * @param {[Number]} imageIndex [图片位置]
         * @param {[Number]} editWidth  [编辑区域宽度]
         * @param {[Boolean]} editable   [是否可编辑]
         */

    }, {
        key: 'setEditorPageStyle',
        value: function setEditorPageStyle(pageIndex, imageIndex, editWidth, editable) {
            if (null == this.layout) return EMPTY;
            var layout = this.layout[pageIndex],
                area = layout.area[imageIndex],
                scale = layout.scale;
            //长宽比
            var wl_radio = layout.tw / layout.th;
            //容器长宽比
            var ar_radio = area.aw / area.ah;
            //缩放比
            var zoom_radio = layout.tw * scale / editWidth;
            //设置容器的样式
            var style = {
                position: 'absolute',
                width: area.aw * scale / zoom_radio + 'px',
                height: area.ah * scale / zoom_radio + 'px',
                left: area.ax * scale / zoom_radio + 'px',
                top: area.ay * scale / zoom_radio + 'px',
                overflow: 'hidden',
                zIndex: 100 + Number(pageIndex),
                backgroundRepeat: 'no-repeat'
            };
            //判断是否有图片,有则进行插入操作,无则跳过
            if (!editable) {
                var currentPhotoObject = this.photo[pageIndex],
                    currentPhoto = this.photo[pageIndex].list;
                var widthContrastRadio = editWidth / this.boxWidth;
                if (undefined != currentPhoto) {
                    var photo = currentPhoto[imageIndex],
                        zoom = Number(photo.zoom == undefined ? 1 : photo.zoom);
                    if (EMPTY == photo.key || photo.width == 0 || photo.key == undefined) {
                        //暂无图片,显示默认图片
                        style.background = 'url(' + defaultImageUrl + ') center no-repeat';
                        style.backgroundPosition = "100% 100%";
                        style.backgroundSize = "100% 100%";
                    } else {
                        //有图片
                        var url = encodeURI(Util.DOMAIN + photo.key + Util.THUMB600 + '/rotate/' + photo.degree),
                            imageScaleWidth = void 0,
                            imageScaleHight = void 0;
                        style.backgroundImage = 'url(' + url + ')';
                        style.backgroundPosition = photo.location.position.left * widthContrastRadio.toFixed(2) + 'px ' + photo.location.position.top * widthContrastRadio.toFixed(2) + 'px';
                        var im_radio = photo.width / photo.height; //图片的长宽比
                        if (ar_radio >= im_radio) {
                            //容器长宽比大于图片的长宽比
                            imageScaleWidth = 100 * zoom + '%';
                            imageScaleHight = "auto";
                        } else {
                            imageScaleWidth = "auto";
                            imageScaleHight = 100 * zoom + '%';
                        }
                        style.backgroundSize = imageScaleWidth + ' ' + imageScaleHight;
                    }
                }
            }
            return style;
        }

        /**
         * 设置容器的样式
         * @param {[type]} pageIndex  [description]
         * @param {[type]} imageIndex [description]
         * @param {[type]} editWidth  [description]
         * @param {[type]} editable   [description]
         */

    }, {
        key: 'setAreaStyle',
        value: function setAreaStyle(pageIndex, imageIndex, editWidth, editable) {
            if (null == this.layout) return EMPTY;
            var layout = this.layout[pageIndex],
                area = layout.area[imageIndex],
                scale = layout.scale;
            //长宽比
            var wl_radio = layout.tw / layout.th;
            //容器长宽比
            var ar_radio = area.aw / area.ah;
            //缩放比
            var zoom_radio = layout.tw * scale / editWidth;
            //设置容器的样式
            var style = {
                position: 'absolute',
                width: area.aw * scale / zoom_radio + 'px',
                height: area.ah * scale / zoom_radio + 'px',
                left: area.ax * scale / zoom_radio + 'px',
                top: area.ay * scale / zoom_radio + 'px',
                overflow: 'hidden',
                zIndex: 100 + pageIndex,
                backgroundRepeat: 'no-repeat'
            };
            return style;
        }

        /**
         * 设置模糊滤镜图片样式
         * @param {[type]} pageIndex  [description]
         * @param {[type]} imageIndex [description]
         * @param {[type]} editWidth  [description]
         * @param {[type]} editable   [description]
         */

    }, {
        key: 'setBlurImageStyle',
        value: function setBlurImageStyle(pageIndex, imageIndex, editWidth, editable) {
            if (null == this.layout) return EMPTY;
            var layout = this.layout[pageIndex],
                area = layout.area[imageIndex],
                scale = layout.scale;
            //长宽比
            var wl_radio = layout.tw / layout.th;
            //容器长宽比
            var ar_radio = area.aw / area.ah;
            //缩放比
            var zoom_radio = layout.tw * scale / editWidth;
            //设置容器的样式
            var style = {
                left: '0px',
                top: '0px',
                zIndex: -1
            };
            //判断是否有图片,有则进行插入操作,无则跳过
            if (!editable) {
                var currentPhotoObject = this.photo[pageIndex],
                    currentPhoto = this.photo[pageIndex].list;
                if (undefined != currentPhoto) {
                    var photo = currentPhoto[imageIndex],
                        imageScaleWidth = void 0,
                        imageScaleHight = void 0;
                    var im_radio = photo.width / photo.height; //图片的长宽比
                    if (ar_radio >= im_radio) {
                        //容器长宽比大于图片的长宽比
                        style.width = '100%';
                        style.height = "auto";
                    } else {
                        style.width = "auto";
                        style.height = '100%';
                    }
                }
            }
            return style;
        }

        /**
         * 设置前置图片样式
         * @param {[type]} pageIndex  [description]
         * @param {[type]} imageIndex [description]
         * @param {[type]} editWidth  [description]
         * @param {[type]} editable   [description]
         */

    }, {
        key: 'setFrontImageStyle',
        value: function setFrontImageStyle(pageIndex, imageIndex, editWidth, editable) {
            if (null == this.layout) return EMPTY;
            var layout = this.layout[pageIndex],
                area = layout.area[imageIndex],
                scale = layout.scale;
            //长宽比
            var wl_radio = layout.tw / layout.th;
            //容器长宽比
            var ar_radio = area.aw / area.ah;
            //缩放比
            var zoom_radio = layout.tw * scale / editWidth;
            //缩放的容器宽高
            var scale_area_width = area.aw * scale / zoom_radio,
                scale_area_height = area.ah * scale / zoom_radio;
            //设置容器的样式
            var style = {
                position: 'absolute',
                overflow: 'hidden',
                zIndex: 300 + pageIndex
            };
            //判断是否有图片,有则进行插入操作,无则跳过
            if (!editable) {
                var currentPhotoObject = this.photo[pageIndex],
                    currentPhoto = this.photo[pageIndex].list;
                var widthContrastRadio = editWidth / this.boxWidth;
                if (undefined != currentPhoto) {
                    var photo = currentPhoto[imageIndex],
                        zoom = Number(photo.zoom == undefined ? 1 : photo.zoom);
                    var url = encodeURI(Util.DOMAIN + photo.key + Util.THUMB600 + '/rotate/' + photo.degree),
                        imageScaleWidth = void 0,
                        imageScaleHight = void 0;
                    var im_radio = photo.width / photo.height; //图片的长宽比
                    if (ar_radio >= im_radio) {
                        //容器长宽比大于图片的长宽比
                        style.width = "auto";
                        style.height = "100%";
                        imageScaleHight = scale_area_height;
                        imageScaleWidth = scale_area_height * im_radio;
                        style.left = Number((scale_area_width - imageScaleWidth) / 2).toFixed(2) + 'px';
                        style.top = '0px';
                    } else {
                        style.width = "100%";
                        style.height = 'auto';
                        imageScaleHight = scale_area_width / im_radio;
                        imageScaleWidth = scale_area_width;
                        style.left = '0px';
                        style.top = Number((scale_area_height - imageScaleHight) / 2).toFixed(2) + 'px';
                    }
                }
            }
            return style;
        }

        /**
         * 设置图片样式
         * @param {[Number]} pageIndex  [页数]
         * @param {[Number]} imageIndex [图片位置]
         */

    }, {
        key: 'setPhotoStyle',
        value: function setPhotoStyle(pageIndex, imageIndex) {
            var layout = this.layout[pageIndex],
                area = layout.area[imageIndex];
            //长宽比
            var wl_radio = layout.tw / layout.th;
            //容器长宽比
            var ar_radio = area.aw / area.ah;
            //缩放比
            var zoom_radio = layout.tw / this.boxWidth;
            var currentPhoto = this.photo[pageIndex].list;
            if (undefined != currentPhoto) {
                var photo = currentPhoto[imageIndex],
                    imageScaleWidth = void 0,
                    imageScaleHight = void 0,
                    zoom = Number(photo.zoom == undefined ? 1 : photo.zoom);
                var style = {
                    position: 'absolute',
                    left: photo.location.position.left.toFixed(2) + 'px',
                    top: photo.location.position.top.toFixed(2) + 'px'
                };
                if (EMPTY == photo.key || photo.width == 0 || photo.key == undefined) {
                    style.width = '100%';
                    style.height = '100%';
                } else {
                    var im_radio = photo.width / photo.height; //图片的长宽比
                    if (ar_radio >= im_radio) {
                        imageScaleWidth = 100 * zoom + '%';
                        imageScaleHight = "auto";
                    } else {
                        imageScaleWidth = "auto";
                        imageScaleHight = 100 * zoom + '%';
                    }
                    style.width = imageScaleWidth;
                    style.height = imageScaleHight;
                }
                return style;
            }

            return EMPTY;
        }

        /**
         * 清空滤镜状态
         * @param  {[type]} pageIndex  [description]
         * @param  {[type]} imageIndex [description]
         * @return {[type]}            [description]
         */

    }, {
        key: 'clearBlurStatus',
        value: function clearBlurStatus(pageIndex, imageIndex) {
            var photoList = this.photo;
            var photoItem = this.photo[pageIndex];
            var listItem = photoItem.list[imageIndex];
            if (undefined != listItem && null != listItem) {
                listItem.blur = false;
            }
            return photoItem.list;
        }

        /**
         * 设置图片滤镜状态
         * @param  {[type]} pageIndex  [description]
         * @param  {[type]} imageIndex [description]
         * @return {[type]}            [description]
         */

    }, {
        key: 'addBlurStatus',
        value: function addBlurStatus(pageIndex, imageIndex) {
            var photoList = this.photo;
            var photoItem = this.photo[pageIndex];
            var listItem = photoItem.list[imageIndex];
            if (undefined != listItem && null != listItem) {
                listItem.blur = true;
            }
            return photoItem.list;
        }

        /**
         * 更新照片容器
         * @param  {[type]} index [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'updatePhotoContainer',
        value: function updatePhotoContainer(index) {
            var photoList = this.photo;
            var currentLayout = this.layout[index];
            var page = {};
            page.list = [];
            page.size = currentLayout.area.length;
            page.temp = currentLayout.id;
            page.bw = this.boxWidth;
            page.dpr = document.documentElement.getAttribute('data-dpr');
            page.main = currentLayout.layoutStyle.main;
            page.sub = currentLayout.layoutStyle.sub;
            page.wait = 0; //初始化待插入的位置为0
            for (var j = 0; j < page.size; j++) {
                var pageItem = this.getPhotoItemInitData(j);
                page.list.push(pageItem);
            }
            photoList[index] = this.updatePhotoContent(index, page);
            this.photo = photoList;
            return page;
        }

        /**
         * 用jquery对象列表填充图片
         * @param  {[type]} $list [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'fillImageByGroup',
        value: function fillImageByGroup($list) {
            var photoList = this.photo,
                index = 0; //index不得大于$list.length
            for (var i = 0; i < photoList.length; i++) {
                var item = photoList[i],
                    m_list = item.list;
                if (undefined != m_list) {
                    while (item.size > item.wait) {
                        if (index == $list.length) {
                            //无图片可插入,直接退出
                            break;
                        }
                        var $image = $($list[index]).find('img');
                        m_list[item.wait] = this.fillImageData(i, item.wait, $image);
                        item.wait += 1;
                        index++;
                    }
                }
            }
            this.photo = photoList;

            return this;
        }

        /**
         * 根据分组图片进行填充
         * @param  {[type]} sortableList [description]
         * @return {[type]}              [description]
         */

    }, {
        key: 'fillImageBySortableGroup',
        value: function fillImageBySortableGroup(sortableList) {
            var photoList = this.photo,
                index = 0; //index不得大于$list.length
            for (var i = 0; i < photoList.length; i++) {
                var item = photoList[i],
                    m_list = item.list;
                if (undefined != m_list) {
                    //过滤扉页
                    while (item.size > item.wait) {
                        if (index == sortableList.length) {
                            //无图片可插入,直接退出
                            break;
                        }
                        var sortItem = sortableList[index];
                        m_list[item.wait] = this.getPhotoItemInitData(item.wait, {
                            width: sortItem.width,
                            height: sortItem.height,
                            key: sortItem.key,
                            degree: sortItem.degree,
                            page: i
                        });
                        item.wait += 1;
                        index++;
                    }
                }
            }
            this.photo = photoList;
            return this;
        }

        /**
         * 对图片列表进行分组操作
         * @param  {[type]} $list [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'splitGroupImageObject',
        value: function splitGroupImageObject($list) {
            var group = [];
            $list.each(function () {
                var $image = $(this).find('img');
                var width = $image.attr('data-width'),
                    height = $image.attr('data-height'),
                    degree = $image.attr('data-degree'),
                    key = $image.attr('data-key');
                group.push({
                    width: width,
                    height: height,
                    key: key,
                    degree: degree
                });
            });
            return group;
        }

        /**
         * 用图片数据列表填充图片
         * @param  {[type]} imageList [description]
         * @return {[type]}           [description]
         */

    }, {
        key: 'fillImageByList',
        value: function fillImageByList(imageList) {
            var photoList = this.photo,
                index = 0; //index不得大于$list.length
            for (var i = 0; i < photoList.length; i++) {
                var item = photoList[i],
                    m_list = item.list;
                if (undefined != m_list) {
                    while (item.size > item.wait) {
                        if (index == sortableList.length) {
                            //无图片可插入,直接退出
                            break;
                        }
                        var sortItem = sortableList[index];
                        m_list[item.wait] = this.getPhotoItemInitData(item.wait, {
                            width: sortItem.width,
                            height: sortItem.height,
                            key: sortItem.key,
                            degree: sortItem.degree,
                            page: i
                        });
                        item.wait += 1;
                        index++;
                    }
                }
            }
            this.photo = photoList;
            return this;
        }

        /**
         * 根据页数填充图片
         * @param  {[type]} $list [description]
         * @param  {[type]} page  [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'fillImageByPage',
        value: function fillImageByPage($list, page) {
            var photoList = this.photo,
                index = 0; //index不得大于$list.length
            var item = photoList[page],
                p_list = item.list;
            if (undefined != p_list) {
                while (item.size > item.wait) {
                    if (index == $list.length) {
                        //无图片可插入,直接退出
                        break;
                    }
                    var $image = $($list[index]).find('img');
                    for (var i = 0, len = p_list.length; i < len; i++) {
                        if (p_list[i].key == '') {
                            p_list[i] = this.fillImageData(Number(page), i, $image);
                            break;
                        }
                    }
                    item.wait += 1;
                    index++;
                }
            }
            this.photo = photoList;
            return this;
            //TODO 临时temp-photo
        }

        /**
         * 单页内根据下标填充图片
         * @param  {[type]} list  [description]
         * @param  {[type]} page  [description]
         * @param  {[type]} index [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'fillImageByIndex',
        value: function fillImageByIndex(list, page, index) {
            //只有一张图片
            var $image = $(list[0]).find('img');
            var photoList = this.photo;
            var item = photoList[page],
                p_list = item.list;
            p_list[index] = this.fillImageData(Number(page), Number(index), $image);
            this.photo = photoList;
            return this;
            //TODO 临时temp-photo
        }

        /**
         * 向图片列表中填充图片数据
         * @param  {[Number]} page       [description]
         * @param  {[Number]} imageIndex [description]
         * @param  {[Object]} $image     [description]
         * @return {[object]}            [description]
         */

    }, {
        key: 'fillImageData',
        value: function fillImageData(page, imageIndex, $image) {
            var width = $image.attr('data-width'),
                height = $image.attr('data-height'),
                degree = $image.attr('data-degree'),
                key = $image.attr('data-key');
            return this.getPhotoItemInitData(imageIndex, {
                width: width,
                height: height,
                key: key,
                degree: degree,
                page: page
            });
        }

        /**
         * 根据下标删除图片
         * @param  {[Number]} page  [description]
         * @param  {[Number]} index [description]
         */

    }, {
        key: 'deleteImageByIndex',
        value: function deleteImageByIndex(page, index) {
            var photoList = this.photo;
            var currentPhoto = photoList[page];
            //插入序列减一
            if (currentPhoto.wait > 0) {
                currentPhoto.wait -= 1;
            }
            currentPhoto.list[index] = this.getPhotoItemInitData(index);
            this.photo = photoList;
            return currentPhoto;
        }

        /**
         * 更换图片间顺序
         * @param  {[Number]} pageIndex    [页数]
         * @param  {[Number]} lastIndex    [待替换下标]
         * @param  {[Number]} currentIndex [当前下标]
         * @return {[type]}              [description]
         */

    }, {
        key: 'exchangeImage',
        value: function exchangeImage(pageIndex, lastIndex, currentIndex) {
            var photoList = this.photo;
            var item = photoList[pageIndex],
                p_list = item.list;
            var lastImage = p_list[lastIndex],
                currentImage = p_list[currentIndex];
            //互换位置,缩放比例还原为1
            p_list[lastIndex] = this.getPhotoItemInitData(lastIndex, {
                width: currentImage.width,
                height: currentImage.height,
                degree: currentImage.degree,
                key: currentImage.key,
                page: pageIndex
            });

            p_list[currentIndex] = this.getPhotoItemInitData(currentIndex, {
                width: lastImage.width,
                height: lastImage.height,
                degree: lastImage.degree,
                key: lastImage.key,
                page: pageIndex
            });
            this.photo = photoList;
            return item;
        }

        /**
         * 旋转图片
         * @param  {[type]} pageIndex  [description]
         * @param  {[type]} imageIndex [description]
         * @return {[type]}            [description]
         */

    }, {
        key: 'rotateImage',
        value: function rotateImage(pageIndex, imageIndex) {
            var photoList = this.photo;
            var currentPhoto = photoList[pageIndex];
            if (undefined != currentPhoto.list) {
                var item = currentPhoto.list[imageIndex],
                    width = item.width,
                    height = item.height,
                    degree = item.degree;
                currentPhoto.list[imageIndex] = this.getPhotoItemInitData(imageIndex, {
                    width: height,
                    height: width,
                    key: item.key,
                    degree: (Number(degree) + 90) % 360,
                    page: pageIndex
                });
                console.log(item);
            }
            this.photo = photoList;
            console.log(currentPhoto);
            return currentPhoto;
        }

        /**
         * 放大或缩小图片
         * @param  {[type]} page  [description]
         * @param  {[type]} index [description]
         * @param  {[type]} type  [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'zoomImage',
        value: function zoomImage(page, index, type) {
            var currentPage = this.reCalMovingLimit(page, index, type);
            if (null === currentPage) return null;
            var position = currentPage.location.position;
            var zoomW = void 0,
                zoomH = void 0;
            if (position.dir === 'V') {
                zoomW = currentPage.zoom * 100 + '%';
                zoomH = 'auto';
            } else if (position.dir === 'L') {
                zoomH = currentPage.zoom * 100 + '%';
                zoomW = 'auto';
            }
            return {
                position: 'absolute',
                left: position.left,
                top: position.top,
                width: zoomW,
                height: zoomH
            };
        }

        /**
         * 重新计算图片拖动限制
         * @param  {[type]} page  [description]
         * @param  {[type]} index [description]
         * @param  {[type]} type  [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'reCalMovingLimit',
        value: function reCalMovingLimit(page, index, type) {
            var photoList = this.photo;
            var currentPage = photoList[page].list[index];
            if (type === 1) {
                if (currentPage.zoom >= 2) {
                    return null;
                }
                currentPage.zoom = (currentPage.zoom * 100 + 20) / 100;
            }
            if (type === 0) {
                if (currentPage.zoom <= 1) {
                    if (this.openFilter && !currentPage.fitable) {
                        currentPage.blur = true;
                        this.photo = photoList;
                    }
                    return null;
                }
                currentPage.zoom = (currentPage.zoom * 100 - 20) / 100;
            }
            //缩放系数变化比
            var zoomRate = type === 1 ? 1.2 : 0.8;
            //获取相关容器
            var currentLayout = this.layout[page];
            var area = currentLayout.area[index];
            var position = {};
            var ar_radio = area.aw / area.ah;
            var zoom_radio = currentLayout.tw / this.boxWidth;
            var im_radio = currentPage.width / currentPage.height; //图片的长宽比
            if (ar_radio >= im_radio) {
                var scaleWidthRadio = area.aw / zoom_radio * currentPage.zoom / Number(currentPage.width),
                    maxTop = 0,
                    minTop = -Number((currentPage.height * scaleWidthRadio - area.ah / zoom_radio).toFixed(2)),
                    maxLeft = 0,
                    minLeft = -Number((currentPage.width * scaleWidthRadio - area.aw / zoom_radio).toFixed(2)),
                    zoomWidthStep = type === 1 ? -Number(area.aw / zoom_radio * 0.1) : area.aw / zoom_radio * 0.1,
                    zoomHeightStep = zoomWidthStep / im_radio,
                    left = currentPage.location.position.left + zoomWidthStep,
                    top = currentPage.location.position.top + zoomHeightStep;
                position = {
                    dir: 'V', //垂直方向拖拽
                    maxTop: maxTop,
                    minTop: minTop,
                    maxLeft: maxLeft,
                    minLeft: minLeft,
                    left: left >= maxLeft ? maxLeft : left <= minLeft ? minLeft : left,
                    top: top >= maxTop ? maxTop : top <= minTop ? minTop : top
                };
            } else {
                var scaleHeightRadio = area.ah / zoom_radio * currentPage.zoom / Number(currentPage.height),
                    _maxLeft = 0,
                    _minLeft = -Number((Number(currentPage.width) * scaleHeightRadio - area.aw / zoom_radio).toFixed(2)),
                    _maxTop = 0,
                    _minTop = -Number((Number(currentPage.height) * scaleHeightRadio - area.ah / zoom_radio).toFixed(2)),
                    _zoomHeightStep = type === 1 ? -Number(area.ah / zoom_radio * 0.1) : area.ah / zoom_radio * 0.1,
                    _zoomWidthStep = _zoomHeightStep * im_radio,
                    _left = currentPage.location.position.left + _zoomWidthStep,
                    _top = currentPage.location.position.top + _zoomHeightStep;
                position = {
                    dir: 'L', //水平方向拖拽
                    maxLeft: _maxLeft,
                    minLeft: _minLeft,
                    maxTop: _maxTop,
                    minTop: _minTop,
                    left: _left >= _maxLeft ? _maxLeft : _left <= _minLeft ? _minLeft : _left,
                    top: _top >= _maxTop ? _maxTop : _top <= _minTop ? _minTop : _top
                };
            }
            currentPage.location.position = position;
            this.photo = photoList;
            return currentPage;
        }

        /**
         * 开始拖拽
         * @param  {[type]} e      [description]
         * @param  {[type]} target [description]
         * @return {[type]}        [description]
         */

    }, {
        key: 'touchStart',
        value: function touchStart(e, target) {
            if (e.targetTouches.length === 1) {
                var $edit = $('.edit')[0];
                var touch = e.targetTouches[0],
                    image = target === undefined ? e.target : target;
                return {
                    x: touch.pageX - $edit.offsetLeft,
                    y: touch.pageY - $edit.offsetTop,
                    ix: image.offsetLeft,
                    iy: image.offsetTop
                };
            }
        }

        /**
         * 拖拽移动事件
         * @param e
         * @param startPosition
         * @param position
         */

    }, {
        key: 'touchMove',
        value: function touchMove(e, startPosition, position, target) {
            if (e.targetTouches.length == 1) {
                if (undefined == startPosition) return;
                var touch = e.targetTouches[0],
                    image = undefined === target ? e.target : target,
                    $edit = $('.edit')[0];
                var evx = touch.pageX - $edit.offsetLeft,
                    evy = touch.pageY - $edit.offsetLeft;
                var spanX = evx - startPosition.x,
                    spanY = evy - startPosition.y;
                var currentLeft = $(image).position().left,
                    currentTop = $(image).position().top,
                    zoom = Number($(image).attr('data-zoom') == null ? 1 : $(image).attr('data-zoom'));
                //未缩放图片保持拖拽限制
                if (zoom === 1) {
                    if (image.style.height == 'auto') {
                        if (currentTop >= position.minTop - 10 && currentTop <= position.maxTop + 10) {
                            $(image).css({
                                top: startPosition.iy + spanY
                            });
                        }
                    } else if (image.style.width == 'auto') {
                        if (currentLeft >= position.minLeft - 10 && currentLeft <= position.maxLeft + 10) {
                            $(image).css({
                                left: startPosition.ix + spanX
                            });
                        }
                    }
                } else {
                    //缩放过会的图片可左右拖动
                    $(image).css({
                        top: startPosition.iy + spanY,
                        left: startPosition.ix + spanX
                    });
                }
            }
        }

        /**
         *
         * @param e
         * @param page
         * @param index
         * @param position
         * @param target
         */

    }, {
        key: 'touchEnd',
        value: function touchEnd(e, page, index, position, target) {
            var image = undefined == target ? e.target : target,
                imageZoom = $(image).attr('data-zoom');
            if (image.className.indexOf('front_img') > -1) return;
            var zoom = Number(imageZoom == null ? 1 : imageZoom),
                currentPosition = $(image).position();
            if (zoom === 1) {
                if (image.style.height == 'auto') {
                    if (position.maxTop >= position.minTop) {
                        if (currentPosition.top >= position.maxTop) {
                            $(image).css({
                                top: position.maxTop
                            });
                        } else if (currentPosition.top <= position.minTop) {
                            $(image).css({
                                top: position.minTop
                            });
                        }
                    } else {}
                } else if (image.style.width == 'auto') {
                    if (position.maxLeft >= position.minLeft) {
                        if (currentPosition.left >= position.maxLeft) {
                            $(image).css({
                                left: position.maxLeft
                            });
                        } else if (currentPosition.left <= position.minLeft) {
                            $(image).css({
                                left: position.minLeft
                            });
                        }
                    } else {}
                }
            } else {
                if (position.maxLeft >= position.minLeft && position.maxTop >= position.minTop) {
                    $(image).css({
                        left: currentPosition.left >= position.maxLeft ? position.maxLeft : currentPosition.left <= position.minLeft ? position.minLeft : currentPosition.left,
                        top: currentPosition.top >= position.maxTop ? position.maxTop : currentPosition.top <= position.minTop ? position.minTop : currentPosition.top
                    });
                } else {}
            }

            this.cachePhotoAfterMoving($(image), page, index);
            return true;
        }

        /**
         * 即时缓存拖拽数据
         * @param $image
         * @param page
         * @param index
         */

    }, {
        key: 'cachePhotoAfterMoving',
        value: function cachePhotoAfterMoving($image, page, index) {
            var photoList = this.photo;
            var list = photoList[page].list;
            var position = $image.position();
            list[index].location.position.left = position.left;
            list[index].location.position.top = position.top;
            this.photo = photoList;
        }

        /**
         * 将图片对象转换为数组
         * @param  {[type]} $list [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'convertObject2Array',
        value: function convertObject2Array($list) {
            var group = [];
            $list.each(function () {
                var $image = $(this).find('img');
                var width = $image.attr('data-width'),
                    height = $image.attr('data-height'),
                    degree = $image.attr('data-degree'),
                    key = $image.attr('data-key');
                group.push({
                    width: width,
                    height: height,
                    key: key,
                    degree: degree
                });
            });
            return group;
        }

        /**
         * 修改容器模板
         * @param  {[type]} index [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'changeLayoutItem',
        value: function changeLayoutItem(index) {
            var photoList = this.photo;
            //缓存当前的图片模板-保证只缓存一个当前页
            if (null == this.temp) {
                this.temp = photoList[index];
            }
            var currentLayout = this.layout[index];
            var page = {};
            page.list = [];
            page.size = currentLayout.area.length;
            page.temp = currentLayout.id;
            page.bw = this.boxWidth;
            page.dpr = document.documentElement.getAttribute('data-dpr');
            page.main = currentLayout.layoutStyle.main;
            page.sub = currentLayout.layoutStyle.sub;
            page.wait = 0; //初始化待插入的位置为0
            for (var j = 0; j < page.size; j++) {
                var pageItem = this.getPhotoItemInitData(j);
                page.list.push(pageItem);
            }
            photoList[index] = this.updatePhotoContent(index, page);
            this.photo = photoList;
            return page;
        }

        /**
         * 更新容器内图片数据
         * @param  {[type]} pageIndex [description]
         * @param  {[type]} photoObj  [description]
         * @return {[type]}           [description]
         */

    }, {
        key: 'updatePhotoContent',
        value: function updatePhotoContent(pageIndex, photoObj) {
            if (undefined == photoObj.list) return;
            var cachePhoto = this.temp;
            var list = cachePhoto.list;
            for (var i = 0; i < list.length; i++) {
                var item = list[i],
                    pageItem = photoObj.list[i];
                if (item.key != EMPTY && undefined != pageItem) {
                    photoObj.list[i] = this.getPhotoItemInitData(i, {
                        width: item.width,
                        height: item.height,
                        key: item.key,
                        degree: item.degree,
                        page: pageIndex
                    });
                    photoObj.wait += 1;
                }
            }
            return photoObj;
        }

        /**
         * 照片列表单项初始数据
         * @param  {[type]} index [description]
         * @param  {[type]} data  [description]
         * @return {[type]}       [description]
         */

    }, {
        key: 'getPhotoItemInitData',
        value: function getPhotoItemInitData(index, data) {
            var defaultData = {
                width: 0,
                height: 0,
                key: '',
                degree: 0,
                zoom: 1,
                fitable: true,
                blur: false,
                location: {
                    position: {
                        left: 0,
                        top: 0
                    },
                    layoutIndex: Number(index) + 1
                }
            };
            //填充默认数据
            if (undefined == data) {
                return defaultData;
            }

            //按数据填充,图片自动居中
            var layout = this.layout[data.page];
            var area = layout.area[index];
            if (undefined == area) {
                return defaultData;
            }
            var ar_radio = area.aw / area.ah;
            var zoom_radio = layout.tw / this.boxWidth;
            var im_radio = data.width / data.height; //图片的长宽比
            var fitable = ar_radio >= 1 && im_radio >= 1 || ar_radio < 1 && im_radio < 1;
            var position = {};
            if (ar_radio >= im_radio) {
                var scaleWidthRadio = area.aw / zoom_radio / data.width;
                position = {
                    maxTop: 0,
                    minTop: -(data.height * scaleWidthRadio - area.ah / zoom_radio).toFixed(2),
                    left: 0,
                    top: -((data.height * scaleWidthRadio - area.ah / zoom_radio) / 2).toFixed(2)
                };
            } else {
                var scaleHeightRadio = area.ah / zoom_radio / data.height;
                position = {
                    maxLeft: 0,
                    minLeft: -(data.width * scaleHeightRadio - area.aw / zoom_radio).toFixed(2),
                    left: -((data.width * scaleHeightRadio - area.aw / zoom_radio) / 2).toFixed(2),
                    top: 0
                };
            }
            return {
                width: data.width,
                height: data.height,
                key: data.key,
                degree: data.degree,
                fitable: fitable,
                blur: this.openFilter ? undefined == data.blur ? !fitable : data.blur : false,
                zoom: undefined == data.zoom ? 1 : data.zoom,
                location: {
                    position: position,
                    layoutIndex: Number(index) + 1
                }
            };
        }
    }]);

    return MCanvas;
}();

export default MCanvas;